# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from featurenav_base/Landmark.msg. Do not edit."""
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import geometry_msgs.msg
import featurenav_base.msg

class Landmark(genpy.Message):
  _md5sum = "7449eff7c2b0115aa5f0bb17dcb9db81"
  _type = "featurenav_base/Landmark"
  _has_header = False #flag to mark the presence of a Header object
  _full_text = """# Feature descriptors.
Feature descriptor

# Position of feature in the image when first detected.
geometry_msgs/Point u

# Position of feature in the image when last detected.
geometry_msgs/Point v

# Distance from segment start associated to u.
float64 du

# Distance from segment start associated to v.
float64 dv

================================================================================
MSG: featurenav_base/Feature
# Implementation-dependent feature descriptor.

uint64[] udata
int64[] idata
float64[] fdata

================================================================================
MSG: geometry_msgs/Point
# This contains the position of a point in free space
float64 x
float64 y
float64 z
"""
  __slots__ = ['descriptor','u','v','du','dv']
  _slot_types = ['featurenav_base/Feature','geometry_msgs/Point','geometry_msgs/Point','float64','float64']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       descriptor,u,v,du,dv

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(Landmark, self).__init__(*args, **kwds)
      #message fields cannot be None, assign default values for those that are
      if self.descriptor is None:
        self.descriptor = featurenav_base.msg.Feature()
      if self.u is None:
        self.u = geometry_msgs.msg.Point()
      if self.v is None:
        self.v = geometry_msgs.msg.Point()
      if self.du is None:
        self.du = 0.
      if self.dv is None:
        self.dv = 0.
    else:
      self.descriptor = featurenav_base.msg.Feature()
      self.u = geometry_msgs.msg.Point()
      self.v = geometry_msgs.msg.Point()
      self.du = 0.
      self.dv = 0.

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      length = len(self.descriptor.udata)
      buff.write(_struct_I.pack(length))
      pattern = '<%sQ'%length
      buff.write(struct.pack(pattern, *self.descriptor.udata))
      length = len(self.descriptor.idata)
      buff.write(_struct_I.pack(length))
      pattern = '<%sq'%length
      buff.write(struct.pack(pattern, *self.descriptor.idata))
      length = len(self.descriptor.fdata)
      buff.write(_struct_I.pack(length))
      pattern = '<%sd'%length
      buff.write(struct.pack(pattern, *self.descriptor.fdata))
      _x = self
      buff.write(_struct_8d.pack(_x.u.x, _x.u.y, _x.u.z, _x.v.x, _x.v.y, _x.v.z, _x.du, _x.dv))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    try:
      if self.descriptor is None:
        self.descriptor = featurenav_base.msg.Feature()
      if self.u is None:
        self.u = geometry_msgs.msg.Point()
      if self.v is None:
        self.v = geometry_msgs.msg.Point()
      end = 0
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      pattern = '<%sQ'%length
      start = end
      end += struct.calcsize(pattern)
      self.descriptor.udata = struct.unpack(pattern, str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      pattern = '<%sq'%length
      start = end
      end += struct.calcsize(pattern)
      self.descriptor.idata = struct.unpack(pattern, str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      pattern = '<%sd'%length
      start = end
      end += struct.calcsize(pattern)
      self.descriptor.fdata = struct.unpack(pattern, str[start:end])
      _x = self
      start = end
      end += 64
      (_x.u.x, _x.u.y, _x.u.z, _x.v.x, _x.v.y, _x.v.z, _x.du, _x.dv,) = _struct_8d.unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e) #most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      length = len(self.descriptor.udata)
      buff.write(_struct_I.pack(length))
      pattern = '<%sQ'%length
      buff.write(self.descriptor.udata.tostring())
      length = len(self.descriptor.idata)
      buff.write(_struct_I.pack(length))
      pattern = '<%sq'%length
      buff.write(self.descriptor.idata.tostring())
      length = len(self.descriptor.fdata)
      buff.write(_struct_I.pack(length))
      pattern = '<%sd'%length
      buff.write(self.descriptor.fdata.tostring())
      _x = self
      buff.write(_struct_8d.pack(_x.u.x, _x.u.y, _x.u.z, _x.v.x, _x.v.y, _x.v.z, _x.du, _x.dv))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    try:
      if self.descriptor is None:
        self.descriptor = featurenav_base.msg.Feature()
      if self.u is None:
        self.u = geometry_msgs.msg.Point()
      if self.v is None:
        self.v = geometry_msgs.msg.Point()
      end = 0
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      pattern = '<%sQ'%length
      start = end
      end += struct.calcsize(pattern)
      self.descriptor.udata = numpy.frombuffer(str[start:end], dtype=numpy.uint64, count=length)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      pattern = '<%sq'%length
      start = end
      end += struct.calcsize(pattern)
      self.descriptor.idata = numpy.frombuffer(str[start:end], dtype=numpy.int64, count=length)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      pattern = '<%sd'%length
      start = end
      end += struct.calcsize(pattern)
      self.descriptor.fdata = numpy.frombuffer(str[start:end], dtype=numpy.float64, count=length)
      _x = self
      start = end
      end += 64
      (_x.u.x, _x.u.y, _x.u.z, _x.v.x, _x.v.y, _x.v.z, _x.du, _x.dv,) = _struct_8d.unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e) #most likely buffer underfill

_struct_I = genpy.struct_I
_struct_8d = struct.Struct("<8d")
